--- old/usr/src/uts/common/fs/fifofs/fifosubr.c	Wed Nov  8 03:44:23 2017
+++ new/usr/src/uts/common/fs/fifofs/fifosubr.c	Wed Nov  8 03:44:23 2017
@@ -22,6 +22,9 @@
 
 /*
  * Copyright (c) 1988, 2010, Oracle and/or its affiliates. All rights reserved.
+ *
+ * Copyright 2017 Ivan Richwalski <ivan@seppuku.net>
+ *
  */
 
 /*
@@ -552,12 +555,13 @@
 
 /*
  * Attempt to establish a unique pipe id.  Only un-named pipes use this
- * routine.
+ * routine. Use a 32-bit ino_t so any 32-bit processes that aren't large
+ * file aware can still stat() a pipe fd and not fail with EOVERFLOW.
  */
 ino_t
 fifogetid(void)
 {
-	static ino_t fifo_ino = 0;
+	static ino32_t fifo_ino = 0;
 	ino_t fino;
 
 	mutex_enter(&fino_lock);
